searchNodes=[{"type":"module","title":"ExOpenAi","doc":"","ref":"ExOpenAi.html"},{"type":"module","title":"ExOpenAi.Api","doc":"The main module for the ExOpenAi API client. Provides a wrapper around Httpoison for making requests to the OpenAI API.","ref":"ExOpenAi.Api.html"},{"type":"function","title":"ExOpenAi.Api.auth_header/1","doc":"Builds the authorization header for the request.","ref":"ExOpenAi.Api.html#auth_header/1"},{"type":"function","title":"ExOpenAi.Api.auth_header/2","doc":"Builds the actual authorization header for the request. Examples iex&gt; ExOpenAi.Api.auth_header([], {&quot;api123&quot;, &quot;org345&quot;}) [{&quot;Authorization&quot;, &quot;Bearer api123&quot;}, {&quot;OpenAI-Organization&quot;, &quot;org345&quot;}] iex&gt; ExOpenAi.Api.auth_header([], {&quot;api123&quot;, nil}) [{&quot;Authorization&quot;, &quot;Bearer api123&quot;}]","ref":"ExOpenAi.Api.html#auth_header/2"},{"type":"function","title":"ExOpenAi.Api.client/0","doc":"","ref":"ExOpenAi.Api.html#client/0"},{"type":"function","title":"ExOpenAi.Api.create/3","doc":"Create a new resource in the OpenAI API with a POST request. Examples ExOpenAi.Api . create ( ExOpenAi.Completion , [ prompt : &quot;tell me a joke&quot; , max_tokens : 500 ] ) { :ok , % Completion { ... } } ExOpenAi.Api . create ( ExOpenAi.Completion , [ ] ) { :error , %{ &quot;model&quot; =&gt; &quot;model is required&quot; } , 400 }","ref":"ExOpenAi.Api.html#create/3"},{"type":"function","title":"ExOpenAi.Api.create_stream/3","doc":"Creates a stream using the provided module, data, and options. The stream is created using the Stream.resource/3 function, where the initial function posts the data with Api.post!/4 , the intermediate function processes the async response with StreamProcessor.handle_async_response/2 , and the after function closes the async response with StreamProcessor.close_async_response/1 . Parameters module - The module to be used for handling the data stream. data - A keyword list containing the data to be sent in the request. options - An optional keyword list of additional options for the request. Returns A stream that is created using the Stream.resource/3 function, allowing processing of the data as it is received. Usage This function is used to create a stream with the specified module, process ID, data, and options. This enables efficient handling of streaming data from the OpenAI API. Note that this is the only function that uses HTTPoison, Tesla does not have good support for streaming.","ref":"ExOpenAi.Api.html#create_stream/3"},{"type":"function","title":"ExOpenAi.Api.create_with_file/4","doc":"Create with a file upload. Thing to note: The file parameter is required Additional data that has a list of binaries in it is currently supported. But if the nature of the form shifts so that nested data within a value may not work. Examples ExOpenAi.Api . create_with_file ( ExOpenAi.Completion , [ prompt : &quot;tell me a joke&quot; , max_tokens : 500 ] ) { :ok , % Completion { ... } } ExOpenAi.Api . create_with_file ( ExOpenAi.Completion , [ ] ) { :error , %{ &quot;model&quot; =&gt; &quot;model is required&quot; } , 400 }","ref":"ExOpenAi.Api.html#create_with_file/4"},{"type":"function","title":"ExOpenAi.Api.delete/3","doc":"Perform a DELETE request. See request/1 or request/2 for options definition. delete ( &quot;/users&quot; ) delete ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) delete ( client , &quot;/users&quot; ) delete ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) delete ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"ExOpenAi.Api.html#delete/3"},{"type":"function","title":"ExOpenAi.Api.delete!/3","doc":"Perform a DELETE request. See request!/1 or request!/2 for options definition. delete! ( &quot;/users&quot; ) delete! ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) delete! ( client , &quot;/users&quot; ) delete! ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) delete! ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"ExOpenAi.Api.html#delete!/3"},{"type":"function","title":"ExOpenAi.Api.ensure_valid_filename/1","doc":"","ref":"ExOpenAi.Api.html#ensure_valid_filename/1"},{"type":"function","title":"ExOpenAi.Api.format_data/1","doc":"","ref":"ExOpenAi.Api.html#format_data/1"},{"type":"function","title":"ExOpenAi.Api.get/3","doc":"Perform a GET request. See request/1 or request/2 for options definition. get ( &quot;/users&quot; ) get ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) get ( client , &quot;/users&quot; ) get ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) get ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"ExOpenAi.Api.html#get/3"},{"type":"function","title":"ExOpenAi.Api.get!/3","doc":"Perform a GET request. See request!/1 or request!/2 for options definition. get! ( &quot;/users&quot; ) get! ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) get! ( client , &quot;/users&quot; ) get! ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) get! ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"ExOpenAi.Api.html#get!/3"},{"type":"function","title":"ExOpenAi.Api.head/3","doc":"Perform a HEAD request. See request/1 or request/2 for options definition. head ( &quot;/users&quot; ) head ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) head ( client , &quot;/users&quot; ) head ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) head ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"ExOpenAi.Api.html#head/3"},{"type":"function","title":"ExOpenAi.Api.head!/3","doc":"Perform a HEAD request. See request!/1 or request!/2 for options definition. head! ( &quot;/users&quot; ) head! ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) head! ( client , &quot;/users&quot; ) head! ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) head! ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"ExOpenAi.Api.html#head!/3"},{"type":"function","title":"ExOpenAi.Api.list/2","doc":"List all the resource in the OpenAI API. Examples ExOpenAi.Api . list ( ExOpenAi.Completion ) { :ok , [ % Completion { ... } ] }","ref":"ExOpenAi.Api.html#list/2"},{"type":"function","title":"ExOpenAi.Api.options/3","doc":"Perform a OPTIONS request. See request/1 or request/2 for options definition. options ( &quot;/users&quot; ) options ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) options ( client , &quot;/users&quot; ) options ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) options ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"ExOpenAi.Api.html#options/3"},{"type":"function","title":"ExOpenAi.Api.options!/3","doc":"Perform a OPTIONS request. See request!/1 or request!/2 for options definition. options! ( &quot;/users&quot; ) options! ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) options! ( client , &quot;/users&quot; ) options! ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) options! ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"ExOpenAi.Api.html#options!/3"},{"type":"function","title":"ExOpenAi.Api.patch/4","doc":"Perform a PATCH request. See request/1 or request/2 for options definition. patch ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) patch ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] ) patch ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) patch ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] )","ref":"ExOpenAi.Api.html#patch/4"},{"type":"function","title":"ExOpenAi.Api.patch!/4","doc":"Perform a PATCH request. See request!/1 or request!/2 for options definition. patch! ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) patch! ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] ) patch! ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) patch! ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] )","ref":"ExOpenAi.Api.html#patch!/4"},{"type":"function","title":"ExOpenAi.Api.post/4","doc":"Perform a POST request. See request/1 or request/2 for options definition. post ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) post ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] ) post ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) post ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] )","ref":"ExOpenAi.Api.html#post/4"},{"type":"function","title":"ExOpenAi.Api.post!/4","doc":"Perform a POST request. See request!/1 or request!/2 for options definition. post! ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) post! ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] ) post! ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) post! ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] )","ref":"ExOpenAi.Api.html#post!/4"},{"type":"function","title":"ExOpenAi.Api.process_request_headers/1","doc":"","ref":"ExOpenAi.Api.html#process_request_headers/1"},{"type":"function","title":"ExOpenAi.Api.put/4","doc":"Perform a PUT request. See request/1 or request/2 for options definition. put ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) put ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] ) put ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) put ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] )","ref":"ExOpenAi.Api.html#put/4"},{"type":"function","title":"ExOpenAi.Api.put!/4","doc":"Perform a PUT request. See request!/1 or request!/2 for options definition. put! ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) put! ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] ) put! ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) put! ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] )","ref":"ExOpenAi.Api.html#put!/4"},{"type":"function","title":"ExOpenAi.Api.remove/3","doc":"Delete a resource from the OpenAI API. Examples ExOpenAi.Api . delete ( ExOpenAi.Modle , &quot;gpt-4-turbo&quot; ) { :ok , % Completion { ... } }","ref":"ExOpenAi.Api.html#remove/3"},{"type":"function","title":"ExOpenAi.Api.request/2","doc":"Perform a request. Options :method - the request method, one of [ :head , :get , :delete , :trace , :options , :post , :put , :patch ] :url - either full url e.g. &quot; http://example.com/some/path&quot; or just &quot;/some/path&quot; if using Tesla.Middleware.BaseUrl :query - a keyword list of query params, e.g. [page: 1, per_page: 100] :headers - a keyworld list of headers, e.g. [{&quot;content-type&quot;, &quot;text/plain&quot;}] :body - depends on used middleware: by default it can be a binary if using e.g. JSON encoding middleware it can be a nested map if adapter supports it it can be a Stream with any of the above :opts - custom, per-request middleware or adapter options Examples ExampleApi . request ( method : :get , url : &quot;/users/path&quot; ) # use shortcut methods ExampleApi . get ( &quot;/users/1&quot; ) ExampleApi . post ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } )","ref":"ExOpenAi.Api.html#request/2"},{"type":"function","title":"ExOpenAi.Api.request!/2","doc":"Perform request and raise in case of error. This is similar to request/2 behaviour from Tesla 0.x See request/2 for list of available options.","ref":"ExOpenAi.Api.html#request!/2"},{"type":"function","title":"ExOpenAi.Api.retrieve/3","doc":"Retrieve a resource from the OpenAI API. Examples ExOpenAi.Api . retrieve ( ExOpenAi.Modle , &quot;gpt-4-turbo&quot; ) { :ok , % Completion { ... } }","ref":"ExOpenAi.Api.html#retrieve/3"},{"type":"function","title":"ExOpenAi.Api.trace/3","doc":"Perform a TRACE request. See request/1 or request/2 for options definition. trace ( &quot;/users&quot; ) trace ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) trace ( client , &quot;/users&quot; ) trace ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) trace ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"ExOpenAi.Api.html#trace/3"},{"type":"function","title":"ExOpenAi.Api.trace!/3","doc":"Perform a TRACE request. See request!/1 or request!/2 for options definition. trace! ( &quot;/users&quot; ) trace! ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) trace! ( client , &quot;/users&quot; ) trace! ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) trace! ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"ExOpenAi.Api.html#trace!/3"},{"type":"type","title":"ExOpenAi.Api.data/0","doc":"","ref":"ExOpenAi.Api.html#t:data/0"},{"type":"type","title":"ExOpenAi.Api.option/0","doc":"Options that may be passed to a request function. See request/2 for detailed descriptions.","ref":"ExOpenAi.Api.html#t:option/0"},{"type":"module","title":"ExOpenAi.Audio.Speech","doc":"Represents a TTS request to the OpenAI API. OpenAI API Docs Examples iex&gt; params = %{ ...&gt; model : &quot;tts-1&quot; , ...&gt; input : &quot;There was an old man named Michael Finnigan&quot; , ...&gt; response_format : &quot;mp3&quot; , / default is mp3 ...&gt; voice : &quot;alloy&quot; ...&gt; } iex&gt; ExOpenAi.Audio.Speech . create ( params ) { :ok , % ExOpenAi.Audio.Speech { ... } } iex&gt; ExOpenAi.Audio.Speech . create ( %{ } ) { :error , %{ } }","ref":"ExOpenAi.Audio.Speech.html"},{"type":"function","title":"ExOpenAi.Audio.Speech.create/2","doc":"","ref":"ExOpenAi.Audio.Speech.html#create/2"},{"type":"function","title":"ExOpenAi.Audio.Speech.do_new/2","doc":"","ref":"ExOpenAi.Audio.Speech.html#do_new/2"},{"type":"function","title":"ExOpenAi.Audio.Speech.new/0","doc":"","ref":"ExOpenAi.Audio.Speech.html#new/0"},{"type":"function","title":"ExOpenAi.Audio.Speech.new/1","doc":"","ref":"ExOpenAi.Audio.Speech.html#new/1"},{"type":"type","title":"ExOpenAi.Audio.Speech.t/0","doc":"","ref":"ExOpenAi.Audio.Speech.html#t:t/0"},{"type":"module","title":"ExOpenAi.Audio.Transcription","doc":"Represents a transcription request to the OpenAI API. OpenAI API Docs Notes The file must be a local file path, as URLs are not currently supported. If you need to transcribe audio from a URL, you will need to implement that functionality yourself. On large bodies of text it can really take a while to process. Its recommended to stream to a process to save or play the file. Examples iex&gt; params = %{ ...&gt; model : &quot;whisper-1&quot; , ...&gt; file : &quot;path/to/some_file.mp3&quot; ...&gt; } iex&gt; ExOpenAi.Audio.Transcription . create ( params ) { :ok , % ExOpenAi.Audio.Transcription { ... } } iex&gt; ExOpenAi.Audio.Transcription . create ( %{ } ) { :error , %{ } }","ref":"ExOpenAi.Audio.Transcription.html"},{"type":"function","title":"ExOpenAi.Audio.Transcription.create/1","doc":"","ref":"ExOpenAi.Audio.Transcription.html#create/1"},{"type":"function","title":"ExOpenAi.Audio.Transcription.create_with_file/3","doc":"","ref":"ExOpenAi.Audio.Transcription.html#create_with_file/3"},{"type":"function","title":"ExOpenAi.Audio.Transcription.do_new/2","doc":"","ref":"ExOpenAi.Audio.Transcription.html#do_new/2"},{"type":"function","title":"ExOpenAi.Audio.Transcription.keep_it_simple/2","doc":"","ref":"ExOpenAi.Audio.Transcription.html#keep_it_simple/2"},{"type":"function","title":"ExOpenAi.Audio.Transcription.new/0","doc":"","ref":"ExOpenAi.Audio.Transcription.html#new/0"},{"type":"function","title":"ExOpenAi.Audio.Transcription.new/1","doc":"","ref":"ExOpenAi.Audio.Transcription.html#new/1"},{"type":"type","title":"ExOpenAi.Audio.Transcription.t/0","doc":"","ref":"ExOpenAi.Audio.Transcription.html#t:t/0"},{"type":"module","title":"ExOpenAi.Audio.Translation","doc":"Represents a translation request to the OpenAI API. OpenAI API Docs Examples iex&gt; params = %{ ...&gt; model : &quot;whisper-1&quot; , ...&gt; file : &quot;path/to/some_file.mp3&quot; , ...&gt; prompt : &quot;translate this to french&quot; ...&gt; } iex&gt; ExOpenAi.Audio.Translation . create ( params ) { :ok , % ExOpenAi.Audio.Translation { ... } }","ref":"ExOpenAi.Audio.Translation.html"},{"type":"function","title":"ExOpenAi.Audio.Translation.create/1","doc":"","ref":"ExOpenAi.Audio.Translation.html#create/1"},{"type":"function","title":"ExOpenAi.Audio.Translation.create_with_file/3","doc":"","ref":"ExOpenAi.Audio.Translation.html#create_with_file/3"},{"type":"function","title":"ExOpenAi.Audio.Translation.do_new/2","doc":"","ref":"ExOpenAi.Audio.Translation.html#do_new/2"},{"type":"function","title":"ExOpenAi.Audio.Translation.keep_it_simple/2","doc":"","ref":"ExOpenAi.Audio.Translation.html#keep_it_simple/2"},{"type":"function","title":"ExOpenAi.Audio.Translation.new/0","doc":"","ref":"ExOpenAi.Audio.Translation.html#new/0"},{"type":"function","title":"ExOpenAi.Audio.Translation.new/1","doc":"","ref":"ExOpenAi.Audio.Translation.html#new/1"},{"type":"type","title":"ExOpenAi.Audio.Translation.t/0","doc":"","ref":"ExOpenAi.Audio.Translation.html#t:t/0"},{"type":"module","title":"ExOpenAi.Chat","doc":"Represents a chat request to the OpenAI API. OpenAI API Docs Examples iex&gt; params = %{ ...&gt; model : &quot;text-model&quot; , ...&gt; messages : [ ...&gt; %{ content : &quot;hello&quot; } ...&gt; ] ...&gt; } iex&gt; ExOpenAi.Chat . create ( params ) { :ok , % ExOpenAi.Chat { ... } } iex&gt; ExOpenAi.Chat . create ( %{ } ) { :error , %{ } }","ref":"ExOpenAi.Chat.html"},{"type":"function","title":"ExOpenAi.Chat.create/2","doc":"","ref":"ExOpenAi.Chat.html#create/2"},{"type":"function","title":"ExOpenAi.Chat.create_stream/2","doc":"","ref":"ExOpenAi.Chat.html#create_stream/2"},{"type":"function","title":"ExOpenAi.Chat.do_new/2","doc":"","ref":"ExOpenAi.Chat.html#do_new/2"},{"type":"function","title":"ExOpenAi.Chat.keep_it_simple/2","doc":"","ref":"ExOpenAi.Chat.html#keep_it_simple/2"},{"type":"function","title":"ExOpenAi.Chat.new/0","doc":"","ref":"ExOpenAi.Chat.html#new/0"},{"type":"function","title":"ExOpenAi.Chat.new/1","doc":"","ref":"ExOpenAi.Chat.html#new/1"},{"type":"type","title":"ExOpenAi.Chat.t/0","doc":"","ref":"ExOpenAi.Chat.html#t:t/0"},{"type":"module","title":"ExOpenAi.ChatRequest","doc":"Represents a chat request to the OpenAI API. OpenAI API Docs This module allows you to add a message to the list of messages in the request as well as validate any request to the Chat resource. Examples iex&gt; params = %{ ...&gt; model : &quot;text-model&quot; , ...&gt; messages : [ ...&gt; %{ content : &quot;hello&quot; } ...&gt; ] ...&gt; } iex&gt; ExOpenAi.ChatRequest . create ( params ) { :ok , % ExOpenAi.Chat { ... } } iex&gt; ExOpenAi.ChatRequest . do_append ( params , %{ content : &quot;world&quot; } ) %{ model : &quot;text-model&quot; , messages : [ %{ content : &quot;hello&quot; } , %{ content : &quot;world&quot; } ] }","ref":"ExOpenAi.ChatRequest.html"},{"type":"function","title":"ExOpenAi.ChatRequest.create/1","doc":"Builds the create chat request and validates the required fields. Examples iex&gt; params = %{ ...&gt; model : &quot;text-model&quot; , ...&gt; messages : [ ...&gt; %{ role : &quot;system&quot; , content : &quot;hello&quot; } ...&gt; ] ...&gt; } iex&gt; ExOpenAi.ChatRequest . create ( params ) { :ok , % ExOpenAi.Chat { ... } }","ref":"ExOpenAi.ChatRequest.html#create/1"},{"type":"function","title":"ExOpenAi.ChatRequest.delete_invalid_fields/2","doc":"Deletes any fields that are not in the list of fields. Examples iex&gt; params = %{ ...&gt; model : &quot;text-model&quot; , ...&gt; messages : [ ...&gt; %{ content : &quot;hello&quot; } ...&gt; ] ...&gt; } iex&gt; Request . delete_invalid_fields ( params , [ :model , :messages ] ) %{ model : &quot;text-model&quot; , messages : [ %{ content : &quot;hello&quot; } ] }","ref":"ExOpenAi.ChatRequest.html#delete_invalid_fields/2"},{"type":"function","title":"ExOpenAi.ChatRequest.do_append/2","doc":"Builds the chat messages by appending to the list of messages in the map. Examples iex&gt; params = %{ ...&gt; model : &quot;text-model&quot; , ...&gt; messages : [ ...&gt; %{ role : &quot;system&quot; , content : &quot;hello&quot; } ...&gt; ] ...&gt; } iex&gt; ExOpenAi.ChatRequest . do_append ( params , %{ role : &quot;user&quot; , content : &quot;world&quot; } ) %{ model : &quot;text-model&quot; , messages : [ %{ content : &quot;hello&quot; } , %{ content : &quot;world&quot; } ] }","ref":"ExOpenAi.ChatRequest.html#do_append/2"},{"type":"function","title":"ExOpenAi.ChatRequest.do_change/2","doc":"Builds the map by adding to the existing map and updates the map with the attributes passed in. Examples iex&gt; params = %{ ...&gt; model : &quot;text-model&quot; , ...&gt; messages : [ ...&gt; %{ content : &quot;hello&quot; } ...&gt; ] ...&gt; } iex&gt; Request . do_change ( params , promp : &quot;this is a prompt&quot; ) %{ model : &quot;text-model&quot; , messages : [ %{ content : &quot;hello&quot; } ] , prompt : &quot;this is a prompt&quot; }","ref":"ExOpenAi.ChatRequest.html#do_change/2"},{"type":"function","title":"ExOpenAi.ChatRequest.has_required_fields?/2","doc":"Ensures that the map has the required fields. Examples iex&gt; params = %{ model : &quot;text-model&quot; , messages : [ %{ content : &quot;hello&quot; } ] } iex&gt; Request . has_required_fields? ( params , [ :model , :messages ] ) true iex&gt; params = %{ model : &quot;text-model&quot; } iex&gt; Request . has_required_fields? ( params , [ :model , :messages ] ) false","ref":"ExOpenAi.ChatRequest.html#has_required_fields?/2"},{"type":"function","title":"ExOpenAi.ChatRequest.prepare/3","doc":"Prepares the map by removing any fields that are not in the list of fields. and ensures required fields are present. Examples iex&gt; params = %{ ...&gt; model : &quot;text-model&quot; , ...&gt; messages : [ ...&gt; %{ content : &quot;hello&quot; } ...&gt; ] ...&gt; } iex&gt; Request . prepare ( params , [ ] , [ :model , :messages ] ) %{ model : &quot;text-model&quot; , messages : [ %{ content : &quot;hello&quot; } ] } iex&gt; params = %{ ...&gt; model : &quot;text-model&quot; , ...&gt; messages : [ ...&gt; %{ content : &quot;hello&quot; } ...&gt; ] ...&gt; } iex&gt; Request . prepare ( params , [ ] , [ :model , :messages , :prompt ] ) ** (RuntimeError) Required fields are missing","ref":"ExOpenAi.ChatRequest.html#prepare/3"},{"type":"module","title":"ExOpenAi.Completion","doc":"Represents a completion request to the OpenAI API. OpenAI API Docs Examples iex&gt; params = %{ ...&gt; model : &quot;text-model&quot; , ...&gt; prompt : &quot;tell me a joke&quot; , ...&gt; max_tokens : 500 ...&gt; } iex&gt; ExOpenAi.Completion . create ( params ) { :ok , % ExOpenAi.Completion { ... } } iex&gt; ExOpenAi.Completion . create ( %{ } ) { :error , %{ } }","ref":"ExOpenAi.Completion.html"},{"type":"function","title":"ExOpenAi.Completion.create/2","doc":"","ref":"ExOpenAi.Completion.html#create/2"},{"type":"function","title":"ExOpenAi.Completion.create_stream/2","doc":"","ref":"ExOpenAi.Completion.html#create_stream/2"},{"type":"function","title":"ExOpenAi.Completion.do_new/2","doc":"","ref":"ExOpenAi.Completion.html#do_new/2"},{"type":"function","title":"ExOpenAi.Completion.keep_it_simple/2","doc":"","ref":"ExOpenAi.Completion.html#keep_it_simple/2"},{"type":"function","title":"ExOpenAi.Completion.new/0","doc":"","ref":"ExOpenAi.Completion.html#new/0"},{"type":"function","title":"ExOpenAi.Completion.new/1","doc":"","ref":"ExOpenAi.Completion.html#new/1"},{"type":"type","title":"ExOpenAi.Completion.t/0","doc":"","ref":"ExOpenAi.Completion.html#t:t/0"},{"type":"module","title":"ExOpenAi.CompletionRequest","doc":"Represents a completion request to the OpenAI API. OpenAI API Docs","ref":"ExOpenAi.CompletionRequest.html"},{"type":"function","title":"ExOpenAi.CompletionRequest.create/1","doc":"Builds the create completion request and validates the required fields.","ref":"ExOpenAi.CompletionRequest.html#create/1"},{"type":"function","title":"ExOpenAi.CompletionRequest.delete_invalid_fields/2","doc":"Deletes any fields that are not in the list of fields. Examples iex&gt; params = %{ ...&gt; model : &quot;text-model&quot; , ...&gt; messages : [ ...&gt; %{ content : &quot;hello&quot; } ...&gt; ] ...&gt; } iex&gt; Request . delete_invalid_fields ( params , [ :model , :messages ] ) %{ model : &quot;text-model&quot; , messages : [ %{ content : &quot;hello&quot; } ] }","ref":"ExOpenAi.CompletionRequest.html#delete_invalid_fields/2"},{"type":"function","title":"ExOpenAi.CompletionRequest.do_change/2","doc":"Builds the map by adding to the existing map and updates the map with the attributes passed in. Examples iex&gt; params = %{ ...&gt; model : &quot;text-model&quot; , ...&gt; messages : [ ...&gt; %{ content : &quot;hello&quot; } ...&gt; ] ...&gt; } iex&gt; Request . do_change ( params , promp : &quot;this is a prompt&quot; ) %{ model : &quot;text-model&quot; , messages : [ %{ content : &quot;hello&quot; } ] , prompt : &quot;this is a prompt&quot; }","ref":"ExOpenAi.CompletionRequest.html#do_change/2"},{"type":"function","title":"ExOpenAi.CompletionRequest.has_required_fields?/2","doc":"Ensures that the map has the required fields. Examples iex&gt; params = %{ model : &quot;text-model&quot; , messages : [ %{ content : &quot;hello&quot; } ] } iex&gt; Request . has_required_fields? ( params , [ :model , :messages ] ) true iex&gt; params = %{ model : &quot;text-model&quot; } iex&gt; Request . has_required_fields? ( params , [ :model , :messages ] ) false","ref":"ExOpenAi.CompletionRequest.html#has_required_fields?/2"},{"type":"function","title":"ExOpenAi.CompletionRequest.prepare/3","doc":"Prepares the map by removing any fields that are not in the list of fields. and ensures required fields are present. Examples iex&gt; params = %{ ...&gt; model : &quot;text-model&quot; , ...&gt; messages : [ ...&gt; %{ content : &quot;hello&quot; } ...&gt; ] ...&gt; } iex&gt; Request . prepare ( params , [ ] , [ :model , :messages ] ) %{ model : &quot;text-model&quot; , messages : [ %{ content : &quot;hello&quot; } ] } iex&gt; params = %{ ...&gt; model : &quot;text-model&quot; , ...&gt; messages : [ ...&gt; %{ content : &quot;hello&quot; } ...&gt; ] ...&gt; } iex&gt; Request . prepare ( params , [ ] , [ :model , :messages , :prompt ] ) ** (RuntimeError) Required fields are missing","ref":"ExOpenAi.CompletionRequest.html#prepare/3"},{"type":"module","title":"ExOpenAi.Config","doc":"Stores the configuration for the ExOpenAi client. All settings also accept {:system, &quot;ENV_VAR_NAME&quot;} to read their values from environment variables at runtime","ref":"ExOpenAi.Config.html"},{"type":"function","title":"ExOpenAi.Config.api_key/0","doc":"Returns the api_key, set it in mix.exs config :ex_open_ai, api_key: &quot;API_KEY&quot;","ref":"ExOpenAi.Config.html#api_key/0"},{"type":"function","title":"ExOpenAi.Config.from_env/3","doc":"A wrapper around Application.get_env/2 , providing automatic support for {:system, &quot;VARIABLE&quot;} .","ref":"ExOpenAi.Config.html#from_env/3"},{"type":"function","title":"ExOpenAi.Config.organization/0","doc":"Returns the organization, set it in mix.exs config :ex_open_ai, organization: &quot;ORGANIZATION&quot;","ref":"ExOpenAi.Config.html#organization/0"},{"type":"function","title":"ExOpenAi.Config.timeout/0","doc":"Returns the timeout, set it in mix.exs Defaults to 25_000 config :ex_open_ai, timeout: 10_000","ref":"ExOpenAi.Config.html#timeout/0"},{"type":"module","title":"ExOpenAi.DeleteResponse","doc":"","ref":"ExOpenAi.DeleteResponse.html"},{"type":"type","title":"ExOpenAi.DeleteResponse.t/0","doc":"","ref":"ExOpenAi.DeleteResponse.html#t:t/0"},{"type":"module","title":"ExOpenAi.Edit","doc":"Represents an edit request to the OpenAI API. OpenAI API Docs Examples","ref":"ExOpenAi.Edit.html"},{"type":"function","title":"ExOpenAi.Edit.create/2","doc":"","ref":"ExOpenAi.Edit.html#create/2"},{"type":"function","title":"ExOpenAi.Edit.do_new/2","doc":"","ref":"ExOpenAi.Edit.html#do_new/2"},{"type":"function","title":"ExOpenAi.Edit.keep_it_simple/2","doc":"","ref":"ExOpenAi.Edit.html#keep_it_simple/2"},{"type":"function","title":"ExOpenAi.Edit.new/0","doc":"","ref":"ExOpenAi.Edit.html#new/0"},{"type":"function","title":"ExOpenAi.Edit.new/1","doc":"","ref":"ExOpenAi.Edit.html#new/1"},{"type":"type","title":"ExOpenAi.Edit.t/0","doc":"","ref":"ExOpenAi.Edit.html#t:t/0"},{"type":"module","title":"ExOpenAi.Embedding","doc":"Represents an embedding request to the OpenAI API. OpenAI API Docs","ref":"ExOpenAi.Embedding.html"},{"type":"function","title":"ExOpenAi.Embedding.create/2","doc":"","ref":"ExOpenAi.Embedding.html#create/2"},{"type":"function","title":"ExOpenAi.Embedding.do_new/2","doc":"","ref":"ExOpenAi.Embedding.html#do_new/2"},{"type":"function","title":"ExOpenAi.Embedding.keep_it_simple/2","doc":"","ref":"ExOpenAi.Embedding.html#keep_it_simple/2"},{"type":"function","title":"ExOpenAi.Embedding.new/0","doc":"","ref":"ExOpenAi.Embedding.html#new/0"},{"type":"function","title":"ExOpenAi.Embedding.new/1","doc":"","ref":"ExOpenAi.Embedding.html#new/1"},{"type":"type","title":"ExOpenAi.Embedding.t/0","doc":"","ref":"ExOpenAi.Embedding.html#t:t/0"},{"type":"module","title":"ExOpenAi.EmbeddingRequest","doc":"Represents an embedding request to the OpenAI API. OpenAI API Docs","ref":"ExOpenAi.EmbeddingRequest.html"},{"type":"function","title":"ExOpenAi.EmbeddingRequest.create/1","doc":"Builds the create embedding request and validates the required fields.","ref":"ExOpenAi.EmbeddingRequest.html#create/1"},{"type":"function","title":"ExOpenAi.EmbeddingRequest.delete_invalid_fields/2","doc":"Deletes any fields that are not in the list of fields. Examples iex&gt; params = %{ ...&gt; model : &quot;text-model&quot; , ...&gt; messages : [ ...&gt; %{ content : &quot;hello&quot; } ...&gt; ] ...&gt; } iex&gt; Request . delete_invalid_fields ( params , [ :model , :messages ] ) %{ model : &quot;text-model&quot; , messages : [ %{ content : &quot;hello&quot; } ] }","ref":"ExOpenAi.EmbeddingRequest.html#delete_invalid_fields/2"},{"type":"function","title":"ExOpenAi.EmbeddingRequest.do_change/2","doc":"Builds the map by adding to the existing map and updates the map with the attributes passed in. Examples iex&gt; params = %{ ...&gt; model : &quot;text-model&quot; , ...&gt; messages : [ ...&gt; %{ content : &quot;hello&quot; } ...&gt; ] ...&gt; } iex&gt; Request . do_change ( params , promp : &quot;this is a prompt&quot; ) %{ model : &quot;text-model&quot; , messages : [ %{ content : &quot;hello&quot; } ] , prompt : &quot;this is a prompt&quot; }","ref":"ExOpenAi.EmbeddingRequest.html#do_change/2"},{"type":"function","title":"ExOpenAi.EmbeddingRequest.has_required_fields?/2","doc":"Ensures that the map has the required fields. Examples iex&gt; params = %{ model : &quot;text-model&quot; , messages : [ %{ content : &quot;hello&quot; } ] } iex&gt; Request . has_required_fields? ( params , [ :model , :messages ] ) true iex&gt; params = %{ model : &quot;text-model&quot; } iex&gt; Request . has_required_fields? ( params , [ :model , :messages ] ) false","ref":"ExOpenAi.EmbeddingRequest.html#has_required_fields?/2"},{"type":"function","title":"ExOpenAi.EmbeddingRequest.prepare/3","doc":"Prepares the map by removing any fields that are not in the list of fields. and ensures required fields are present. Examples iex&gt; params = %{ ...&gt; model : &quot;text-model&quot; , ...&gt; messages : [ ...&gt; %{ content : &quot;hello&quot; } ...&gt; ] ...&gt; } iex&gt; Request . prepare ( params , [ ] , [ :model , :messages ] ) %{ model : &quot;text-model&quot; , messages : [ %{ content : &quot;hello&quot; } ] } iex&gt; params = %{ ...&gt; model : &quot;text-model&quot; , ...&gt; messages : [ ...&gt; %{ content : &quot;hello&quot; } ...&gt; ] ...&gt; } iex&gt; Request . prepare ( params , [ ] , [ :model , :messages , :prompt ] ) ** (RuntimeError) Required fields are missing","ref":"ExOpenAi.EmbeddingRequest.html#prepare/3"},{"type":"module","title":"ExOpenAi.Files.File","doc":"Represents a file request to the OpenAI API. OpenAI API Docs Examples iex&gt; params = %{ ...&gt; purpose : &quot;search&quot; , ...&gt; file : &quot;file-uuid&quot; ...&gt; } iex&gt; ExOpenAi.Files.File . create ( params ) { :ok , % ExOpenAi.Files.File { ... } } iex&gt; ExOpenAi.Files.File . retrieve ( %{ } ) { :error , %{ } }","ref":"ExOpenAi.Files.File.html"},{"type":"function","title":"ExOpenAi.Files.File.create/1","doc":"","ref":"ExOpenAi.Files.File.html#create/1"},{"type":"function","title":"ExOpenAi.Files.File.create_with_file/3","doc":"","ref":"ExOpenAi.Files.File.html#create_with_file/3"},{"type":"function","title":"ExOpenAi.Files.File.do_new/2","doc":"","ref":"ExOpenAi.Files.File.html#do_new/2"},{"type":"function","title":"ExOpenAi.Files.File.keep_it_simple/2","doc":"","ref":"ExOpenAi.Files.File.html#keep_it_simple/2"},{"type":"function","title":"ExOpenAi.Files.File.list/1","doc":"","ref":"ExOpenAi.Files.File.html#list/1"},{"type":"function","title":"ExOpenAi.Files.File.new/0","doc":"","ref":"ExOpenAi.Files.File.html#new/0"},{"type":"function","title":"ExOpenAi.Files.File.new/1","doc":"","ref":"ExOpenAi.Files.File.html#new/1"},{"type":"function","title":"ExOpenAi.Files.File.remove/2","doc":"","ref":"ExOpenAi.Files.File.html#remove/2"},{"type":"function","title":"ExOpenAi.Files.File.retrieve/2","doc":"","ref":"ExOpenAi.Files.File.html#retrieve/2"},{"type":"type","title":"ExOpenAi.Files.File.t/0","doc":"","ref":"ExOpenAi.Files.File.html#t:t/0"},{"type":"module","title":"ExOpenAi.Images.Image","doc":"Represents a new image request to the OpenAI API. OpenAI API Docs Examples","ref":"ExOpenAi.Images.Image.html"},{"type":"function","title":"ExOpenAi.Images.Image.create/2","doc":"","ref":"ExOpenAi.Images.Image.html#create/2"},{"type":"function","title":"ExOpenAi.Images.Image.do_new/2","doc":"","ref":"ExOpenAi.Images.Image.html#do_new/2"},{"type":"function","title":"ExOpenAi.Images.Image.keep_it_simple/2","doc":"","ref":"ExOpenAi.Images.Image.html#keep_it_simple/2"},{"type":"function","title":"ExOpenAi.Images.Image.new/0","doc":"","ref":"ExOpenAi.Images.Image.html#new/0"},{"type":"function","title":"ExOpenAi.Images.Image.new/1","doc":"","ref":"ExOpenAi.Images.Image.html#new/1"},{"type":"type","title":"ExOpenAi.Images.Image.t/0","doc":"","ref":"ExOpenAi.Images.Image.html#t:t/0"},{"type":"module","title":"ExOpenAi.Model","doc":"Represents a model request to the OpenAI API. OpenAI API Docs Examples","ref":"ExOpenAi.Model.html"},{"type":"function","title":"ExOpenAi.Model.do_new/2","doc":"","ref":"ExOpenAi.Model.html#do_new/2"},{"type":"function","title":"ExOpenAi.Model.keep_it_simple/2","doc":"","ref":"ExOpenAi.Model.html#keep_it_simple/2"},{"type":"function","title":"ExOpenAi.Model.list/1","doc":"","ref":"ExOpenAi.Model.html#list/1"},{"type":"function","title":"ExOpenAi.Model.new/0","doc":"","ref":"ExOpenAi.Model.html#new/0"},{"type":"function","title":"ExOpenAi.Model.new/1","doc":"","ref":"ExOpenAi.Model.html#new/1"},{"type":"function","title":"ExOpenAi.Model.remove/2","doc":"","ref":"ExOpenAi.Model.html#remove/2"},{"type":"function","title":"ExOpenAi.Model.retrieve/2","doc":"","ref":"ExOpenAi.Model.html#retrieve/2"},{"type":"type","title":"ExOpenAi.Model.t/0","doc":"","ref":"ExOpenAi.Model.html#t:t/0"},{"type":"module","title":"ExOpenAi.Moderation","doc":"Represents a moderation request to the OpenAI API. OpenAI API Docs Examples iex&gt; params = %{ ...&gt; input : &quot;I want to kill them all&quot; , ; .. &gt; model : &quot;text-moderation-latest&quot; ...&gt; } iex&gt; ExOpenAi.Moderation . create ( params ) { :ok , % ExOpenAi.Moderation { ... } }","ref":"ExOpenAi.Moderation.html"},{"type":"function","title":"ExOpenAi.Moderation.create/2","doc":"","ref":"ExOpenAi.Moderation.html#create/2"},{"type":"function","title":"ExOpenAi.Moderation.do_new/2","doc":"","ref":"ExOpenAi.Moderation.html#do_new/2"},{"type":"function","title":"ExOpenAi.Moderation.keep_it_simple/2","doc":"","ref":"ExOpenAi.Moderation.html#keep_it_simple/2"},{"type":"function","title":"ExOpenAi.Moderation.new/0","doc":"","ref":"ExOpenAi.Moderation.html#new/0"},{"type":"function","title":"ExOpenAi.Moderation.new/1","doc":"","ref":"ExOpenAi.Moderation.html#new/1"},{"type":"type","title":"ExOpenAi.Moderation.t/0","doc":"","ref":"ExOpenAi.Moderation.html#t:t/0"},{"type":"module","title":"ExOpenAi.NewImageRequest","doc":"Represents a new image request to the OpenAI API. OpenAI API Docs","ref":"ExOpenAi.NewImageRequest.html"},{"type":"function","title":"ExOpenAi.NewImageRequest.create/1","doc":"Builds the create new image request and validates the required fields.","ref":"ExOpenAi.NewImageRequest.html#create/1"},{"type":"function","title":"ExOpenAi.NewImageRequest.delete_invalid_fields/2","doc":"Deletes any fields that are not in the list of fields. Examples iex&gt; params = %{ ...&gt; model : &quot;text-model&quot; , ...&gt; messages : [ ...&gt; %{ content : &quot;hello&quot; } ...&gt; ] ...&gt; } iex&gt; Request . delete_invalid_fields ( params , [ :model , :messages ] ) %{ model : &quot;text-model&quot; , messages : [ %{ content : &quot;hello&quot; } ] }","ref":"ExOpenAi.NewImageRequest.html#delete_invalid_fields/2"},{"type":"function","title":"ExOpenAi.NewImageRequest.do_change/2","doc":"Builds the map by adding to the existing map and updates the map with the attributes passed in. Examples iex&gt; params = %{ ...&gt; model : &quot;text-model&quot; , ...&gt; messages : [ ...&gt; %{ content : &quot;hello&quot; } ...&gt; ] ...&gt; } iex&gt; Request . do_change ( params , promp : &quot;this is a prompt&quot; ) %{ model : &quot;text-model&quot; , messages : [ %{ content : &quot;hello&quot; } ] , prompt : &quot;this is a prompt&quot; }","ref":"ExOpenAi.NewImageRequest.html#do_change/2"},{"type":"function","title":"ExOpenAi.NewImageRequest.has_required_fields?/2","doc":"Ensures that the map has the required fields. Examples iex&gt; params = %{ model : &quot;text-model&quot; , messages : [ %{ content : &quot;hello&quot; } ] } iex&gt; Request . has_required_fields? ( params , [ :model , :messages ] ) true iex&gt; params = %{ model : &quot;text-model&quot; } iex&gt; Request . has_required_fields? ( params , [ :model , :messages ] ) false","ref":"ExOpenAi.NewImageRequest.html#has_required_fields?/2"},{"type":"function","title":"ExOpenAi.NewImageRequest.prepare/3","doc":"Prepares the map by removing any fields that are not in the list of fields. and ensures required fields are present. Examples iex&gt; params = %{ ...&gt; model : &quot;text-model&quot; , ...&gt; messages : [ ...&gt; %{ content : &quot;hello&quot; } ...&gt; ] ...&gt; } iex&gt; Request . prepare ( params , [ ] , [ :model , :messages ] ) %{ model : &quot;text-model&quot; , messages : [ %{ content : &quot;hello&quot; } ] } iex&gt; params = %{ ...&gt; model : &quot;text-model&quot; , ...&gt; messages : [ ...&gt; %{ content : &quot;hello&quot; } ...&gt; ] ...&gt; } iex&gt; Request . prepare ( params , [ ] , [ :model , :messages , :prompt ] ) ** (RuntimeError) Required fields are missing","ref":"ExOpenAi.NewImageRequest.html#prepare/3"},{"type":"module","title":"ExOpenAi.Parser","doc":"Parses the response from the OpenAI API.","ref":"ExOpenAi.Parser.html"},{"type":"function","title":"ExOpenAi.Parser.parse/3","doc":"Parse a response expected to contain a resource. If you pass in a module as the first argument, the JSON will be parsed into that module's __struct__ . Examples Given you have a module named Resource , defined like this: defmodule Resource do defstruct sid : nil end You can parse JSON into that module's struct like so: iex&gt; response = %{ body : &quot;{ \\&quot; id \\&quot; : \\&quot; cmpl-uqkvlQyYK7bGYrRHQ0eXlWi7 \\&quot; }&quot; , status_code : 200 } ...&gt; ExOpenAi.Parser . parse ( response , Resource , nil ) { :ok , % Resource { id : &quot;cmpl-uqkvlQyYK7bGYrRHQ0eXlWi7&quot; } } You can also parse into a regular map if you want. iex&gt; response = %{ body : &quot;{ \\&quot; id \\&quot; : \\&quot; cmpl-uqkvlQyYK7bGYrRHQ0eXlWi7 \\&quot; }&quot; , status_code : 200 } ...&gt; ExOpenAi.Parser . parse ( response , %{ } , nil ) { :ok , %{ &quot;id&quot; =&gt; &quot;cmpl-uqkvlQyYK7bGYrRHQ0eXlWi7&quot; } }","ref":"ExOpenAi.Parser.html#parse/3"},{"type":"function","title":"ExOpenAi.Parser.parse_delete/1","doc":"Parse a deletion request.","ref":"ExOpenAi.Parser.html#parse_delete/1"},{"type":"function","title":"ExOpenAi.Parser.parse_list/3","doc":"Parse a list of resources.","ref":"ExOpenAi.Parser.html#parse_list/3"},{"type":"type","title":"ExOpenAi.Parser.error/0","doc":"","ref":"ExOpenAi.Parser.html#t:error/0"},{"type":"type","title":"ExOpenAi.Parser.http_status_code/0","doc":"","ref":"ExOpenAi.Parser.html#t:http_status_code/0"},{"type":"type","title":"ExOpenAi.Parser.key/0","doc":"","ref":"ExOpenAi.Parser.html#t:key/0"},{"type":"type","title":"ExOpenAi.Parser.metadata/0","doc":"","ref":"ExOpenAi.Parser.html#t:metadata/0"},{"type":"type","title":"ExOpenAi.Parser.parsed_response/0","doc":"","ref":"ExOpenAi.Parser.html#t:parsed_response/0"},{"type":"type","title":"ExOpenAi.Parser.success/0","doc":"","ref":"ExOpenAi.Parser.html#t:success/0"},{"type":"type","title":"ExOpenAi.Parser.success_delete/0","doc":"","ref":"ExOpenAi.Parser.html#t:success_delete/0"},{"type":"module","title":"ExOpenAi.Request","doc":"The base module for all requests in the ExOpenAi API client. Can be used to prepare, validate and update requests. Examples iex&gt; params = %{ ...&gt; model : &quot;text-model&quot; , ...&gt; messages : [ ...&gt; %{ content : &quot;hello&quot; } ...&gt; ] ...&gt; } iex&gt; Request . do_change ( params , promp : &quot;this is a prompt&quot; ) %{ model : &quot;text-model&quot; , messages : [ %{ content : &quot;hello&quot; } ] , prompt : &quot;this is a prompt&quot; }","ref":"ExOpenAi.Request.html"},{"type":"module","title":"ExOpenAi.Resource","doc":"The base module for all resources in the ExOpenAi API client.","ref":"ExOpenAi.Resource.html"},{"type":"module","title":"ExOpenAi.StreamProcessor","doc":"ExOpenAi.StreamProcessor is a module that handles streaming HTTP responses for the ExOpenAi library. It provides functions to process and parse chunks of data as they are received from the HTTP stream. It works with the ExOpenAi.Parser module to parse and decode the received data. Functions close_async_response/1 : Closes the async response by stopping the hackney process. handle_async_response/2 : Handles different types of async responses, such as status, headers, chunks, and end of the stream. parse_chunk/3 : A private function that splits the received chunk, trims it, and decodes it using the provided module. decode_chunk/2 : A private function that decodes the chunk based on its content. If the chunk is &quot;[DONE]&quot;, it returns {:done, &quot;&quot;} , otherwise, it calls the Parser to parse the chunk. Usage The primary use case for this module is to handle streaming HTTP responses from the OpenAI API in a smooth and efficient manner. By working with the ExOpenAi.Parser module, it allows the ExOpenAi library to process the data as it is received, rather than waiting for the entire response.","ref":"ExOpenAi.StreamProcessor.html"},{"type":"function","title":"ExOpenAi.StreamProcessor.close_async_response/1","doc":"","ref":"ExOpenAi.StreamProcessor.html#close_async_response/1"},{"type":"function","title":"ExOpenAi.StreamProcessor.handle_async_response/1","doc":"","ref":"ExOpenAi.StreamProcessor.html#handle_async_response/1"},{"type":"function","title":"ExOpenAi.StreamProcessor.handle_async_response/2","doc":"","ref":"ExOpenAi.StreamProcessor.html#handle_async_response/2"},{"type":"module","title":"ExOpenAi.URLGenerator","doc":"Generates the URL for the API request.","ref":"ExOpenAi.URLGenerator.html"},{"type":"function","title":"ExOpenAi.URLGenerator.infer_url/1","doc":"Infers the URL for the API request based on the module name.","ref":"ExOpenAi.URLGenerator.html#infer_url/1"},{"type":"extras","title":"License","doc":"MIT License Copyright (c) 2023 David Astor Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html"},{"type":"extras","title":"Overview","doc":"ExOpenAi is an elixir wrapper for the OpenAI API. All resources return a struct of the resource that was called.","ref":"readme.html"},{"type":"extras","title":"Overview - Installation","doc":"The package can be installed by adding ex_open_ai to your list of dependencies in mix.exs : def deps do [ { :ex_open_ai , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation"},{"type":"extras","title":"Overview - Configuration","doc":"To access the OpenAI API you will need to set the following environment or runtime variables in your config/config.exs file: config :ex_open_ai , api_key : &quot;YOUR_API_KEY_FROM_OPEN_AI&quot; , organization : &quot;OPTIONAL_ORGANIZATION&quot; , # optional timeout : 30_000 # optional, default is 25_000 You can also use the {:system, &quot;VARIABLE_NAME&quot;} format.","ref":"readme.html#configuration"},{"type":"extras","title":"Overview - Usage","doc":"ExOpenAi has modules for the supported OpenAI API resource. At the time of release not all endpoints are supported, there will be more coming soon. For example the &quot;Completion&quot; resource is available through the ExOpenAi.Completion module. Almost every single resource can be called with the create function. iex&gt; ExOpenAi.Chat . create ( %{ model : &quot;gpt-4-turbo&quot; , [ %{ role : &quot;user&quot; , content : &quot;Tell me a funny story&quot; } ] } ) { :ok , % ExOpenAi.Chat { object : &quot;chat_cmpl&quot; , id : &quot;cmpl-id&quot; , choices : [ %{ text : &quot;funny story&quot; } ] , created : 1234567890 , usage : %{ completion_tokens : 25 , prompt_tokens : 50 , total_tokens : 75 } } } Will return a ExOpenAi.Chat struct with all the information that the API returns.","ref":"readme.html#usage"},{"type":"extras","title":"Overview - Streaming","doc":"ExOpenAi can stream tokens for Chat and Completion. To use it simply call ExOpenAi.Completion.create_stream(%{model: &quot;text-davinci-003&quot;, prompt: &quot;Tell me a funny story&quot;}) This function returns a Stream resource and can be enumerated over. The way Streams work in Elixir the code inside the Stream (the api call to OpenAi) will not be called until the Stream is &quot;ran&quot;. You can do this by enumerating over the stream directly. An example of using the Chat stream inside LiveView: When &quot;creating&quot; the stream, for example inside a phx-submit inside a form. @impl true def handle_event ( &quot;submit_question&quot; , %{ &quot;submit_question&quot; =&gt; question } , socket ) do stream = ExOpenAi.Chat . create_stream ( model : &quot;gpt-3.5-turbo&quot; , messages : [ %{ content : question , role : &quot;user&quot; } ] ) socket = socket |&gt; assign ( :question , question ) # Allows us to listen to when the task is done. |&gt; assign ( :response_task , response_task ( stream ) ) { :noreply , socket } end defp response_task ( stream ) do target = self ( ) Task.Supervisor . async ( TaskSupervisor , fn -&gt; for chunk &lt;- stream do case chunk do { :done , _ } -&gt; send ( target , :done ) { :ok , parsed } -&gt; send ( target , { :cont , parsed } ) end end end ) end This will then send the tokens as they come in to the liveview page and you can handle_info them. @impl true def handle_info ( { :cont , % ExOpenAi.Chat { choices : [ %{ delta : %{ content : content } } ] } } , socket ) do %{ answer : answer } = socket . assigns socket = socket |&gt; assign ( :answer , answer &lt;&gt; content ) { :noreply , socket } end # Optional def handle_info ( :done , socket ) do { :noreply , put_flash ( socket , :info , &quot;Done!&quot; ) } end # When the Task is completed we stop listening for it. Technically not optional, but recommended if you use Task.async def handle_info ( { ref , _answer } , socket ) when socket . assigns . response_task . ref == ref do Process . demonitor ( ref , [ :flush ] ) { :noreply , socket } end","ref":"readme.html#streaming"},{"type":"extras","title":"Overview - Supported Resources","doc":"As of initial release the following resources are supported with more to come: Chat Edits Embeddings Image Whisper Translation Files Moderation Transcription Model","ref":"readme.html#supported-resources"},{"type":"extras","title":"Overview - Copyright and License","doc":"Copyright (c) 2023 David Astor ExOpenAi is licensed under the MIT license. For more details see the LICENSE file at the root of the repo. Elixir is licensed under the Apache 2 license. OpenAI is a trademark of OpenAI","ref":"readme.html#copyright-and-license"}]